#
#	Notice: this client doesn't use the base testclient.py code
#	because this one has to do special tests with creating proxies.
#

import Pyro.naming, Pyro.core
import Pyro.errors

Pyro.core.initClient()
Pyro.config.PYRO_NS_DEFAULTGROUP=':test'	# default namespace group
Pyro.config.PYRO_TRACELEVEL=3
Pyro.config.PYRO_LOGFILE='client_log'
print 'Check the logfile: client_log'

locator = Pyro.naming.NameServerLocator()
print 'Searching Naming Service...',
try:
	ns = locator.getNS()
except (Pyro.core.PyroError,socket.error),x:
	import socket
	hn = socket.gethostname()
	print '\nNaming Service not found with broadcast. Trying host',hn,'...',
	ns = locator.getNS(host=hn)

print 'Naming Service found at',ns.URI.host,ns.URI.port

print 'binding to object'
try:
    URI=ns.resolve('maxclients')
    print 'URI:',URI
except Pyro.core.PyroError,x:
    print 'Couldn\'t bind object, nameserver says:',x
    raise SystemExit


print '---- trying to create a bunch of proxy objects'
objects=[]
for i in range(20):
	ok=0
	while not ok:
		try:
			print 'creating proxy object',i
			obj=Pyro.core.getProxyForURI(URI)
			obj.setname(i)
			objects.append(obj)
			ok=1
		except Pyro.errors.ServerFullError,x:
			# Server denied the new connection.
			# A possible solution is to delete another one we don't need
			# anymore and to try again.
			print 'Error creating proxy object:',x
			print ' -> removing old proxy and trying again...'
			if objects:
				del objects[0]
			

for obj in objects:
	print 'object',id(obj),'is called:',obj.getname()

